# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import Instance, Interface, Str

from .i_storage import IStorage
from .i_storage_location import IStorageLocation


class IStorageBrowser(Interface):
    """ The IStorageBrowser interface defines the API implemented by a view
    that allows the user to browse storage and select a valid
    :term:`storage location`.
    """

    # This explains why the storage location is invalid.  It will be an empty
    # string if the location is valid.
    invalid_reason = Str()

    # The storage location that the user uses the view to set.
    location = Instance(IStorageLocation)

    # The storage.
    storage = Instance(IStorage)
