# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import Any, Interface, Str


class IPublication(Interface):
    """ The IPublication interface defines the API to be implemented by a model
    that represents an event related to a published model.
    """

    # The event related to the model.  The following events are considered to
    # be well known.
    #
    # 'dip.events.opened'
    #   occurs once just after the model has been opened or created.
    # 'dip.events.closed'
    #   occurs once just before the model is closed.
    # 'dip.event.active'
    #   occurs whenever the model becomes active.
    # 'dip.events.inactive'
    #   occurs whenever the model becomes inactive.
    event = Str()

    # The model being published.
    model = Any()
