# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QGroupBox

from ....model import adapt
from ....ui import IGroupBox

from ..single_qlayout_container_adapter import SingleQLayoutContainerAdapter


@adapt(QGroupBox, to=IGroupBox)
class QGroupBoxIGroupBoxAdapter(SingleQLayoutContainerAdapter):
    """ An adapter to implement IGroupBox for a QGroupBox. """

    @IGroupBox.title.getter
    def title(self):
        """ Invoked to get the title. """

        return self.adaptee.title()

    @title.setter
    def title(self, value):
        """ Invoked to set the title. """

        self.adaptee.setTitle(value)
