# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import (QApplication, QHBoxLayout, QLineEdit, QStyle,
        QToolButton)


class DipStorageLocationEditor(QHBoxLayout):
    """ The DipStorageLocationEditor class implements a storage location editor
    based on a line edit and a browse button.
    """

    def __init__(self, parent):
        """ Initialise the editor.

        :param parent:
            is the optional parent widget.
        """

        super().__init__(parent)

        self.setContentsMargins(0, 0, 0, 0)

        line_edit = QLineEdit()
        self.addWidget(line_edit)

        self.addWidget(
                QToolButton(
                        icon=QApplication.style().standardIcon(
                                QStyle.SP_DirIcon), toolTip="Browse"))

        # If we get converted to a widget then we need the focus proxy set.
        self.qt4_focus_proxy = line_edit
