# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import List

from .single_subview_container_factory import SingleSubviewContainerFactory


class Dialog(SingleSubviewContainerFactory):
    """ The Dialog class implements a dialog factory, i.e. it creates views
    that implement the :class:`~dip.ui.IDialog` interface.
    """

    # The contents should always be automatically wrapped in a
    # :class:`~dip.ui.Form`.
    auto_form = 'always'

    # The identifier of each widget created by the factory.
    id = 'dip.dialog'

    # The name of the toolkit factory method.
    toolkit_factory = 'dialog'

    @SingleSubviewContainerFactory.controller_factory.default
    def controller_factory(self):
        """ Invoked to return the default controller factory. """

        from .dialog_controller import DialogController

        return DialogController
