# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import Bool

from .editor_factory import EditorFactory


class FilesystemLocationEditor(EditorFactory):
    """ The FilesystemLocationEditor class implements a filesystem location
    editor factory.  Note that :class:`~dip.ui.StorageLocationEditor` should
    normally be used instead.
    """

    # This is set if a value is required.
    required = Bool(False)

    # The name of the toolkit factory method.
    toolkit_factory = 'filesystem_location_editor'

    def set_default_validator(self, view):
        """ Sets a view's default validator.

        :param view:
            is the view.
        """

        from .filesystem_location_validator import FilesystemLocationValidator

        view.validator = FilesystemLocationValidator(mode=view.mode,
                required=self.required)
