# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import List

from .container_factory import ContainerFactory
from .tab_page import TabPage


class TabBar(ContainerFactory):
    """ The TabBar class is a container for a number of
    :class:`~dip.ui.TabPage` sub-views.
    """

    # The contents of the view.
    contents = List(TabPage)

    # The name of the toolkit factory method.
    toolkit_factory = 'tab_bar'
