# Copyright (c) 2012 Riverbank Computing Limited.


try:
    import unittest2 as unittest
except ImportError:
    import unittest

from dip.model import Singleton


class TestSingleton(unittest.TestCase):
    """ This tests the Singleton class. """

    def test_instantiation(self):
        """ Instantiate a singleton. """

        class Klass(Singleton): pass

        k = Klass()

        self.assertIs(Klass.singleton, k)

    def test_multiple_subclasses(self):
        """ Make sure singleton sub-classes are independent. """

        class Klass1(Singleton): pass

        class Klass2(Singleton): pass

        self.assertIsNot(Klass1(), Klass2())

    def test_multi_instantiation(self):
        """ Try to instantiate a singleton more than once. """

        class Klass(Singleton): pass

        self.assertIs(Klass(), Klass())


if __name__ == '__main__':
    unittest.main()
