# Copyright (c) 2012 Riverbank Computing Limited.


if __name__ == '__main__':
    import sys
    from PyQt4.QtGui import QApplication

    app = QApplication(sys.argv)


try:
    import unittest2 as unittest
except ImportError:
    import unittest


import os

from dip.automate import Robot
from dip.model import Model, Str
from dip.ui import Bindings, Designer


class TestDesigner(unittest.TestCase):
    """ This tests the Designer factory. """

    def test_designer(self):
        """ Test a .ui file. """

        class TestModel(Model):
            attr = Str("Replace this...")

        model = TestModel()
        ui_file = os.path.join(os.path.dirname(__file__), 'test_designer.ui')
        view_factory = Designer(ui_file, bindings=Bindings(lineEdit='attr'))
        view = view_factory(model=model)
        view.visible = True

        Robot.simulate('lineEdit', 'set', "...with this")
        self.assertEqual(model.attr, "...with this")


if __name__ == '__main__':
    unittest.main()
