# Copyright (c) 2012 Riverbank Computing Limited.


if __name__ == '__main__':
    import sys
    from PyQt4.QtGui import QApplication

    app = QApplication(sys.argv)


try:
    import unittest2 as unittest
except ImportError:
    import unittest

from PyQt4.QtGui import QWizard

from dip.automate import Robot
from dip.model import Model
from dip.ui import HBox, Wizard, WizardPage


class TestWizard(unittest.TestCase):
    """ This tests the Wizard view. """

    def test_finish(self):
        """ Test Wizard Finish button. """

        model = Model()
        view_factory = Wizard(WizardPage(HBox()), id='Wizard.finish')
        view = view_factory(model=model)

        robot = Robot()
        robot.record('Wizard.finish', 'click', QWizard.FinishButton)
        robot.play(after=0)

        accepted = view.execute()

        # Verify that the wizard returned the expected value.
        self.assertTrue(accepted)

    def test_cancel(self):
        """ Test Wizard Cancel button. """

        model = Model()
        view_factory = Wizard(WizardPage(HBox()), id='Wizard.cancel')
        view = view_factory(model=model)

        robot = Robot()
        robot.record('Wizard.cancel', 'click', QWizard.CancelButton)
        robot.play(after=0)

        accepted = view.execute()

        # Verify that the wizard returned the expected value.
        self.assertFalse(accepted)


if __name__ == '__main__':
    unittest.main()
